package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.util.Iterator;
import java.util.List;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityListMarshaller;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.NoncompliantResourceException;

import ognl.Ognl;
import ognl.OgnlException;

public class EntityListMarshallerImpl implements EntityListMarshaller {

    private static final String IDENTIFIER_PROPERTY_NAME = "id";
    private static final String LIST_ELEMENT_SUFFIX = "List";

    public String marshal(List resourceList, String resourceName, String listUri) {
        StringBuffer sb = new StringBuffer();
        sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
        sb.append("<" + resourceName + LIST_ELEMENT_SUFFIX +
                " xmlns:xlink=\"http://www.w3.org/1999/xlink\">");
        
        for (Iterator iter = resourceList.iterator(); iter.hasNext();) {
            String id = getIdValueFrom(iter.next());
            sb.append("<" + resourceName + " id=\"" + id + "\"" +
                    " xlink:href=\"" + listUri + "/" + id + "\"/>");
        }
        
        sb.append("</" + resourceName + LIST_ELEMENT_SUFFIX + ">");
        return sb.toString();
    }

    private String getIdValueFrom(Object obj) {
        try {
            return String.valueOf(Ognl.getValue(IDENTIFIER_PROPERTY_NAME, obj));
        } catch (OgnlException e) {
            throw new NoncompliantResourceException("entity does not have id property", e);
        }
    }
}
