package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import javax.servlet.http.HttpServletRequest;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.DaoOperation;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityRequestRetriever;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.PathInfoTokenizer;

public class EntityRequestRetrieverImpl implements EntityRequestRetriever {
    
    public Object retrieveEntityFor(HttpServletRequest request) {
        String pathInfo = request.getPathInfo();
        Object entity = retrieveEntityFor(pathInfo);
        return entity;
    }
    
    private Object retrieveEntityFor(String pathInfo) {
        String daoPrefix = pathInfoTokenizer.getDaoPrefix(pathInfo);
        if(pathInfoTokenizer.isListAccess(pathInfo)) {
            return daoOperation.getAll(daoPrefix);
        } else {
            long entityId = pathInfoTokenizer.getEntityId(pathInfo);
            return daoOperation.getById(daoPrefix, entityId);
        }
    }
    
    
    private PathInfoTokenizer pathInfoTokenizer;
    public void setPathInfoTokenizer(PathInfoTokenizer pathInfoTokenizer) {
        this.pathInfoTokenizer = pathInfoTokenizer;
    }
    private DaoOperation daoOperation;
    public void setDaoOperation(DaoOperation daoOperation) {
        this.daoOperation = daoOperation;
    }
}
