package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringReader;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityListMarshaller;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityMarshaller;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityResponseWriter;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.PathInfoTokenizer;

import org.apache.commons.io.IOUtils;

public class EntityResponseWriterImpl implements EntityResponseWriter {

    public void writeEntityTo(
            HttpServletRequest request,
            HttpServletResponse response,
            Object entity) throws IOException
    {
        String pathInfo = request.getPathInfo();
        
        String xml;
        if(pathInfoTokenizer.isListAccess(pathInfo)) {
            String listUri = request.getRequestURL().toString();
            String resourceName = pathInfoTokenizer.getDaoPrefix(pathInfo);
            List resourceList = (List) entity;
            xml = entityListMarshaller.marshal(resourceList, resourceName, listUri);
        } else {
            xml = entityMarshaller.marshal(entity);
        }
        
        response.setContentType("text/xml");
        response.setCharacterEncoding("UTF-8");
        PrintWriter writer = response.getWriter();
        IOUtils.copy(new StringReader(xml), writer);
        writer.flush();
    }
    
    private EntityListMarshaller entityListMarshaller;
    public void setEntityListMarshaller(EntityListMarshaller entityListMarshaller) {
        this.entityListMarshaller = entityListMarshaller;
    }
    private PathInfoTokenizer pathInfoTokenizer;
    public void setPathInfoTokenizer(PathInfoTokenizer pathInfoTokenizer) {
        this.pathInfoTokenizer = pathInfoTokenizer;
    }
    private EntityMarshaller entityMarshaller;
    public void setEntityMarshaller(EntityMarshaller entityMarshaller) {
        this.entityMarshaller = entityMarshaller;
    }
}
