package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import org.apache.commons.lang.math.NumberUtils;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.InvalidPathException;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.PathInfoTokenizer;

public class PathInfoTokenizerImpl implements PathInfoTokenizer {

    private static final int RESOURCE_NAME_INDEX = 1;
    private static final String URI_SEPARATOR = "/";

    public long getEntityId(String pathInfo) {
        return Long.parseLong(getLastToken(pathInfo));
    }

    public String getDaoPrefix(String pathInfo) {
        if(pathInfo == null || URI_SEPARATOR.equals(pathInfo)) {
            throw new InvalidPathException(pathInfo);
        }
        return pathInfo.split(URI_SEPARATOR)[RESOURCE_NAME_INDEX];
    }

    public boolean isListAccess(String pathInfo) {
        return !(NumberUtils.isNumber(getLastToken(pathInfo)));
    }

    private String getLastToken(String pathInfo) {
        String[] tokens = pathInfo.split(URI_SEPARATOR);
        int lastIndex = tokens.length - 1;
        return tokens[lastIndex];
    }

}
