package jp.co.gihyo.webdb.vol35.tdd.webapp.servlet;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.RestOperationDelegate;

import org.seasar.framework.container.S2Container;
import org.seasar.framework.container.factory.SingletonS2ContainerFactory;

public class RestLikeServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
	
	protected void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		String requestUri = req.getRequestURI();
		log("######## doPost" + requestUri);
		res.setHeader("Learning", "GET: " + requestUri);
        RestOperationDelegate delegate = getDelegate();
        delegate.doGet(req, res);
    }

    private RestOperationDelegate getDelegate() {
        S2Container container = getContainer();
        return (RestOperationDelegate) container.getComponent(RestOperationDelegate.class);
    }
    private S2Container getContainer() {
        return SingletonS2ContainerFactory.getContainer();
    }
}
