package jp.co.gihyo.webdb.vol35.tdd.webapp;

import java.io.File;

import junit.framework.Test;
import junitx.util.DirectorySuiteBuilder;
import junitx.util.SimpleTestFilter;
import junitx.util.TestFilter;

public class FindTestUtils {
    
    public static Test findUnitTests(File testDir) throws Exception {
        return buildSuite(testDir, FindTestUtils.unitTestOnlyFilter());
    }
    
    public static Test findFunctionalTests(File testDir) throws Exception {
        return buildSuite(testDir, FindTestUtils.functionalTestOnlyFilter());
    }

    public static TestFilter functionalTestOnlyFilter() {
        return new SimpleTestFilter() {
            public boolean include(String eachTestFilePath) {
                return isFunctionalTest(eachTestFilePath);
            }
        };        
    }
    
    public static TestFilter unitTestOnlyFilter() {
        return new SimpleTestFilter() {
            public boolean include(String eachTestFilePath) {
                return !isFunctionalTest(eachTestFilePath);
            }
        };        
    }
    
    private static Test buildSuite(File testDir, TestFilter filter) throws Exception {
        DirectorySuiteBuilder builder = new DirectorySuiteBuilder(filter);
        return builder.suite(testDir);
    }
    
    private static boolean isFunctionalTest(
            String eachTestFilePath) {
        return new File(eachTestFilePath).getName()
                .startsWith("FunctionalTest");
    }
}
