package jp.co.gihyo.webdb.vol35.tdd.webapp;

import org.custommonkey.xmlunit.XMLTestCase;
import org.custommonkey.xmlunit.XMLUnit;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.DomDriver;

public class XStreamLearningTest extends XMLTestCase {
    XStream xstream;
    protected void setUp() throws Exception {
        xstream = new XStream(new DomDriver());
        XMLUnit.setIgnoreWhitespace(true);
    }

    public static class SampleBean {
        private long id;
        private String name;
        public String getName() {
            return name;
        }
        public void setName(String name) {
            this.name = name;
        }
        public long getId() {
            return id;
        }
        public void setId(long id) {
            this.id = id;
        }
    }
    
    public void testXStreamŃIuWFNgXML𐶐wKeXg() throws Exception {
        SampleBean kent = new SampleBean();
        kent.setId(100);
        kent.setName("kent");
        
        xstream.alias("sampleBean", SampleBean.class);
        String xml = xstream.toXML(kent);
        
        String expected = "<sampleBean><id>100</id><name>kent</name></sampleBean>";
        assertXMLEqual(expected, xml);
    }
    
    public void testtB[hnull̏ꍇɂ̓^ÔoȂ() throws Exception {
        SampleBean nullName = new SampleBean();
        nullName.setId(200);
        nullName.setName(null);
        
        xstream.alias("sampleBean", SampleBean.class);
        String xml = xstream.toXML(nullName);
        
        // TODO null̍ۂɋ^Oo@邩ǂ
        assertXMLEqual("<sampleBean><id>200</id></sampleBean>", xml);
        assertXMLNotEqual("<sampleBean><id>200</id><name></name></sampleBean>", xml);
        assertXMLNotEqual("<sampleBean><id>200</id><name/></sampleBean>", xml);
    }

    
    public static class SampleBean2 {
        private String foo;
        private long bar;
        private int baz;
        public int getBaz() {
            return baz;
        }
        public void setBaz(int baz) {
            this.baz = baz;
        }
        public String getFoo() {
            return foo;
        }
        public void setFoo(String name) {
            this.foo = name;
        }
        public long getBar() {
            return bar;
        }
        public void setBar(long id) {
            this.bar = id;
        }
    }
    public void test^Ȍo͏̓tB[h̐錾ɂȂ() throws Exception {
        SampleBean2 sample2 = new SampleBean2();
        sample2.setBar(200);
        sample2.setFoo("foo");
        sample2.setBaz(3);
        
        xstream.alias("sampleBean2", SampleBean2.class);
        String xml = xstream.toXML(sample2);
        
        assertTrue(xml.indexOf("foo") < xml.indexOf("bar"));
        assertTrue(xml.indexOf("bar") < xml.indexOf("baz"));
    }
    
    
    public static class SampleBean3 {
        private long fId;
        private String fName;
        public String getName() {
            return this.fName;
        }
        public void setName(String name) {
            this.fName = name;
        }
        public long getId() {
            return this.fId;
        }
        public void setId(long id) {
            this.fId = id;
        }
    }
    public void testo͂vfgetter̖Oł͂ȂtB[h̖Og() throws Exception {
        SampleBean3 sample3 = new SampleBean3();
        sample3.setId(300);
        sample3.setName("tail");
        
        xstream.alias("sampleBean3", SampleBean3.class);
        String xml = xstream.toXML(sample3);
        
        String expected = "<sampleBean3><fId>300</fId><fName>tail</fName></sampleBean3>";
        assertXMLEqual(expected, xml);
    }
    
    
    public static class SampleBean4 {
        private long id = 400;
        private String name = "noGetterSetter";
    }
    public void testڃtB[hǂނ̂gettersettersv() throws Exception {
        xstream.alias("sampleBean4", SampleBean4.class);
        String xml = xstream.toXML(new SampleBean4());
        
        String expected = "<sampleBean4><id>400</id><name>noGetterSetter</name></sampleBean4>";
        assertXMLEqual(expected, xml);
    }

    
    public static class SampleBean5 {
        private long _id = 500;
        private String name_ = "underScore";
    }
    public void testA_[XRAt̃tB[h̗vfɂ̓A_[XRAdȂ`ŏo͂() throws Exception {
        xstream.alias("sampleBean5", SampleBean5.class);
        String xml = xstream.toXML(new SampleBean5());
        
        String expected = "<sampleBean5><__id>500</__id><name__>underScore</name__></sampleBean5>";
        assertXMLEqual(expected, xml);
    }
}
