package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.util.List;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.DaoOperation;

import org.seasar.extension.unit.S2TestCase;
import org.seasar.framework.aop.interceptors.MockInterceptor;

public class DaoOperationImplTest extends S2TestCase {
    DaoOperation daoOperation;
    MockInterceptor sampleDaoMock;
    MockInterceptor anotherDaoMock;
    
    public void setUpDaõvtBNXIDDaoĂяos() throws Exception {
        include("DaoOperationTest_case1.dicon");
    }
    public void testDaõvtBNXIDDaoĂяos() throws Exception {
        SampleEntity entity = (SampleEntity) daoOperation.getById("sample", 100);
        assertNotNull(entity);
        assertEquals(100, entity.getId());
        assertEquals("Higa", entity.getName());
        
        assertTrue(sampleDaoMock.isInvoked("getById"));
        Object[] actualArgs = sampleDaoMock.getArgs("getById");
        assertEquals(new Long(100), actualArgs[0]);
    }
    

    public void setUpDaõvtBNXIDDaoĂяosOp()
            throws Exception {
        include("DaoOperationTest_case2.dicon");
    }
    public void testDaõvtBNXIDDaoĂяosOp()
            throws Exception {
        SampleEntity2 entity = (SampleEntity2)
            daoOperation.getById("another", 150);
        assertNotNull(entity);
        assertEquals(150, entity.getId());
        assertEquals("DHH", entity.getNickName());

        assertTrue(anotherDaoMock.isInvoked("getById"));
        Object[] actualArgs =
            anotherDaoMock.getArgs("getById");
        assertEquals(new Long(150), actualArgs[0]);
    }
    
    
    public void setUpDaõvtBNXőSs() throws Exception {
        include("DaoOperationTest_getAll.dicon");
    }
    public void testDaõvtBNXőSs() throws Exception {
        List entities = daoOperation.getAll("sample");
        assertNotNull(entities);
        
        SampleEntity entity = (SampleEntity) entities.get(0);
        assertEquals(100, entity.getId());
        assertEquals("Higa", entity.getName());
        
        SampleEntity entity2 = (SampleEntity) entities.get(1);
        assertEquals(101, entity2.getId());
        assertEquals("koichik", entity2.getName());
        
        assertTrue(sampleDaoMock.isInvoked("getAll"));
    }

    public void setUp\bhgetAll͔zԂDaoɑ΂ĂSs邱()
            throws Exception {
        include("DaoOperationTest_arrayCase.dicon");
    }
    public void test\bhgetAll͔zԂDaoɑ΂ĂSs邱()
            throws Exception {
        List entities = daoOperation.getAll("sampleArray");
        assertNotNull(entities);
        
        SampleEntity2 entity = (SampleEntity2) entities.get(0);
        assertEquals(500, entity.getId());
        assertEquals("Blaze", entity.getNickName());
        
        SampleEntity2 entity2 = (SampleEntity2) entities.get(1);
        assertEquals(501, entity2.getId());
        assertEquals("Cypher", entity2.getNickName());
        
        assertTrue(sampleDaoMock.isInvoked("getAll"));
    }
    
}
