package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.util.List;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityRequestRetriever;

import org.seasar.extension.unit.S2TestCase;
import org.seasar.framework.aop.interceptors.MockInterceptor;
import org.seasar.framework.mock.servlet.MockHttpServletRequest;

public class EntityRequestRetrieverComponentTest extends
        S2TestCase {
    EntityRequestRetriever entityRequestRetriever;
    MockInterceptor sampleDaoMock;

    public void setUpEntityIDURIɃANZXƊYEntityԂ()
            throws Exception {
        include("EntityRequestRetrieverComponentTest.dicon");
    }

    public void testEntityIDURIɃANZXƊYEntityԂ()
            throws Exception {

        // S2Unit񋟂郂bN̂܂܎g
        MockHttpServletRequest mockRequest = getRequest();
        
        mockRequest.setPathInfo("/sample/100");
        SampleEntity entity =
            (SampleEntity) entityRequestRetriever
                .retrieveEntityFor(mockRequest);

        assertNotNull(entity);
        assertEquals(100, entity.getId());
        assertEquals("Higa", entity.getName());

        assertTrue(sampleDaoMock.isInvoked("getById"));
        Object[] actualArgs =
            sampleDaoMock.getArgs("getById");
        assertEquals(new Long(100), actualArgs[0]);
    }


    public void setUpXgURIɃANZXEntitỹXgԂ()
            throws Exception {
        include("EntityRequestRetrieverComponentTest_listUriCase.dicon");
    }

    public void testXgURIɃANZXEntitỹXgԂ()
            throws Exception {

        // S2Unit񋟂郂bN̂܂܎g
        MockHttpServletRequest mockRequest = getRequest();

        mockRequest.setPathInfo("/sample");
        List entities = (List) entityRequestRetriever
                .retrieveEntityFor(mockRequest);
        
        assertNotNull(entities);
        SampleEntity entity = (SampleEntity) entities.get(0);
        assertEquals(100, entity.getId());
        assertEquals("Higa", entity.getName());
        
        SampleEntity entity2 = (SampleEntity) entities.get(1);
        assertEquals(101, entity2.getId());
        assertEquals("koichik", entity2.getName());
        
        assertTrue(sampleDaoMock.isInvoked("getAll"));
    }

}
