package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityResponseWriter;

import org.custommonkey.xmlunit.XMLAssert;
import org.custommonkey.xmlunit.XMLUnit;
import org.seasar.extension.unit.S2TestCase;
import org.seasar.framework.mock.servlet.MockHttpServletRequest;
import org.seasar.framework.mock.servlet.MockHttpServletResponse;
import org.seasar.framework.mock.servlet.MockServletContext;

public class EntityResponseWriterComponentTest extends
        S2TestCase {
    EntityResponseWriter entityResponseWriter;

    
    protected void setUp() throws Exception {
        include("EntityResponseWriterComponentTest.dicon");
        XMLUnit.setIgnoreWhitespace(true);
    }
    
    
    public void testHttpServletResponseEntityXMLďo()
            throws Exception {
        SampleEntity2 entity = new SampleEntity2();
        entity.setId(1000);
        entity.setNickName("daemon lord");

        // S2Unit񋟂郂bNݒ肵Ďg
        MockServletContext mc = getServletContext();
        MockHttpServletRequest mockRequest =
            mc.createRequest("/foo/sample/1000");
        mockRequest.setPathInfo("/sample/1000");
        MockHttpServletResponse mockResponse = getResponse();
        
        entityResponseWriter.writeEntityTo(mockRequest, mockResponse, entity);

        assertEquals("text/xml",
                mockResponse.getContentType());
        assertEquals("UTF-8",
                mockResponse.getCharacterEncoding());

        String expected = "<sampleEntity2>"
                + "<id>1000</id><nickName>daemon lord</nickName>"
                + "</sampleEntity2>";
        PrintWriter actualWriter = mockResponse.getWriter();
        XMLAssert.assertXMLEqual(expected,
                actualWriter.toString());
    }
    
    
    public void testXgURIɃANZXꍇXgXMLďo()
            throws Exception {

        List entityList = new ArrayList();
        SampleEntity sample1 = new SampleEntity();
        sample1.setId(100);
        entityList.add(sample1);
        SampleEntity sample2 = new SampleEntity();
        sample2.setId(101);
        entityList.add(sample2);
        
        
        // S2Unit񋟂郂bNݒ肵Ďg
        MockServletContext mc = getServletContext();
        MockHttpServletRequest mockRequest =
            mc.createRequest("/foo/employee");
        mockRequest.setPathInfo("/employee");
        MockHttpServletResponse mockResponse = getResponse();
        
        entityResponseWriter.writeEntityTo(mockRequest, mockResponse, entityList);

        assertEquals("text/xml", mockResponse.getContentType());
        assertEquals("UTF-8", mockResponse.getCharacterEncoding());

        String expected =
            "<employeeList xmlns:xlink=\"http://www.w3.org/1999/xlink\">" +
            "  <employee id=\"100\" xlink:href=\"http://localhost/foo/employee/100\"/>" +
            "  <employee id=\"101\" xlink:href=\"http://localhost/foo/employee/101\"/>" +
            "</employeeList>";
        PrintWriter actualWriter = mockResponse.getWriter();
        XMLAssert.assertXMLEqual(expected, actualWriter.toString());
    }
}
