package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.InvalidPathException;
import junit.framework.TestCase;

public class PathInfoTokenizerImplTest extends TestCase {

    PathInfoTokenizerImpl tokenizer;
    protected void setUp() throws Exception {
        tokenizer = new PathInfoTokenizerImpl();
    }

    public void testPathInfoEntityID擾() throws Exception {
        assertEquals(5L, tokenizer.getEntityId("/employee/5"));
        assertEquals(6L, tokenizer.getEntityId("/employee/6"));
    }

    public void testPathInfoDaỗvtBNX擾() throws Exception {
        assertEquals("employee", tokenizer.getDaoPrefix("/employee/4"));
        assertEquals("department", tokenizer.getDaoPrefix("/department/7"));
    }

    public void test\bhgetDaoPrefix͈null̂ƂɂInvalidPathException𓊂()
            throws Exception {
        try {
            tokenizer.getDaoPrefix(null);
            fail();
        } catch (InvalidPathException expected) {
            assertNull(expected.getPath());
        }
    }

    public void test\bhgetDaoPrefix͈XbV̂ƂɂInvalidPathException𓊂()
            throws Exception {
        try {
            tokenizer.getDaoPrefix("/");
            fail();
        } catch (InvalidPathException expected) {
            assertEquals("/", expected.getPath());
        }
    }

    public void test\bhisListAccess̓XgURIւ̃ANZX̂ƂtrueԂ()
            throws Exception {
        assertTrue(tokenizer.isListAccess("/employee"));
        assertFalse(tokenizer.isListAccess("/employee/5"));
    }

}
