package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.io.PrintWriter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.RestOperationDelegate;

import org.custommonkey.xmlunit.XMLAssert;
import org.custommonkey.xmlunit.XMLUnit;
import org.seasar.extension.unit.S2TestCase;
import org.seasar.framework.aop.interceptors.MockInterceptor;
import org.seasar.framework.container.ExternalContext;
import org.seasar.framework.mock.servlet.MockHttpServletRequest;
import org.seasar.framework.mock.servlet.MockServletContext;

public class RestOperationDelegateComponentTest extends S2TestCase {
    RestOperationDelegate restOperationDelegate;
    MockInterceptor sampleDaoMock;
    HttpServletRequest request;
    HttpServletResponse response;
    
    protected void setUp() throws Exception {
        XMLUnit.setIgnoreWhitespace(true);
    }

    public void setUp\[XIDURIɃANZXƊY郊\[XXMLԂ()
            throws Exception {
        include("RestOperationDelegateComponentTest_idUriCase.dicon");
        
        // S2Unit񋟂郂bNݒ肵Ďg
        MockServletContext mc = getServletContext();
        MockHttpServletRequest newMock = mc.createRequest("/foo/sample/100");
        newMock.setPathInfo("/sample/100");
        ExternalContext externalContext = getContainer().getExternalContext();
        externalContext.setRequest(newMock);
    }

    public void test\[XIDURIɃANZXƊY郊\[XXMLԂ()
            throws Exception {
        
        restOperationDelegate.doGet(request, response );
        
        assertEquals("text/xml", response.getContentType());
        assertEquals("UTF-8", response.getCharacterEncoding());

        String expected = "<sampleEntity>"
                + "<id>100</id><name>Higa</name>"
                + "</sampleEntity>";
        PrintWriter actualWriter = response.getWriter();
        XMLAssert.assertXMLEqual(expected, actualWriter.toString());
        
        assertTrue(sampleDaoMock.isInvoked("getById"));
        Object[] actualArgs = sampleDaoMock.getArgs("getById");
        assertEquals(new Long(100), actualArgs[0]);
    }


    public void setUpXgURIɃANZXƊY郊\[X̃XgXMLŕԂ()
            throws Throwable {
        include("RestOperationDelegateComponentTest_listUriCase.dicon");
        
        // S2Unit񋟂郂bNݒ肵Ďg
        MockServletContext mc = getServletContext();
        MockHttpServletRequest newMock = mc.createRequest("/foo/sample");
        newMock.setPathInfo("/sample");
        ExternalContext externalContext = getContainer().getExternalContext();
        externalContext.setRequest(newMock);
    }

    public void testXgURIɃANZXƊY郊\[X̃XgXMLŕԂ()
            throws Exception {

        restOperationDelegate.doGet(request, response);

        assertEquals("text/xml", response.getContentType());
        assertEquals("UTF-8", response.getCharacterEncoding());
        
        String expected =
            "<sampleList xmlns:xlink=\"http://www.w3.org/1999/xlink\">" +
            "  <sample id=\"100\" xlink:href=\"http://localhost/foo/sample/100\"/>" +
            "  <sample id=\"101\" xlink:href=\"http://localhost/foo/sample/101\"/>" +
            "</sampleList>";
        PrintWriter actualWriter = response.getWriter();
        XMLAssert.assertXMLEqual(expected, actualWriter.toString());

        assertTrue(sampleDaoMock.isInvoked("getAll"));
    }

}
