package jp.co.gihyo.webdb.vol35.tdd.webapp.servlet;

import java.io.FileReader;
import java.io.InputStreamReader;

import org.custommonkey.xmlunit.XMLTestCase;
import org.custommonkey.xmlunit.XMLUnit;

import com.meterware.httpunit.GetMethodWebRequest;
import com.meterware.httpunit.WebConversation;
import com.meterware.httpunit.WebResponse;

public class FunctionalTestRestLikeServlet extends XMLTestCase {

    WebConversation wc;
    String baseUrl;
    protected void setUp() throws Exception {
        baseUrl =
            "http://localhost:8020/webdb-tdd-webapp-test";
        wc = new WebConversation();
        wc.setExceptionsThrownOnErrorStatus(false);
        XMLUnit.setIgnoreWhitespace(true);
    }
    
	public void testHttpUnit̊wK() throws Exception {
		String url = baseUrl + "/employee/3";
		GetMethodWebRequest req = new GetMethodWebRequest(url);
		WebResponse resp = wc.getResponse(req);

		assertEquals(200, resp.getResponseCode());
		assertEquals("GET: /webdb-tdd-webapp-test/employee/3", resp
				.getHeaderField("Learning"));
	}

	public void testGET\bhIDURIɃANZX() throws Exception {
		String url = baseUrl + "/employee/1";
		GetMethodWebRequest req = new GetMethodWebRequest(url);
		WebConversation wc = new WebConversation();
		WebResponse resp = wc.getResponse(req);

        assertEquals(200, resp.getResponseCode());
        FileReader expectedXml = new FileReader(
                "target/test-classes/expectedIdAccess.xml");
        InputStreamReader actualXml =
            new InputStreamReader(resp.getInputStream());
        assertXMLEqual(expectedXml, actualXml);
	}

    public void testGET\bhIDURIɃANZXOp()
            throws Exception {
        String url = baseUrl + "/employee/5";
        GetMethodWebRequest req =
            new GetMethodWebRequest(url);
        WebResponse resp = wc.getResponse(req);

        assertEquals(200, resp.getResponseCode());
        FileReader expectedXml = new FileReader(
                "target/test-classes/expectedIdAccess2.xml");
        InputStreamReader actualXml =
            new InputStreamReader(resp.getInputStream());
        assertXMLEqual(expectedXml, actualXml);
    }
    
    public void testGET\bhŃXgURIɃANZXƃ\[X̃XgXMLŕԂ()
            throws Exception {
        String url = baseUrl + "/employee";
        GetMethodWebRequest req =
            new GetMethodWebRequest(url);
        WebResponse resp = wc.getResponse(req);

        assertEquals(200, resp.getResponseCode());
        FileReader expectedXml = new FileReader(
                "target/test-classes/expectedListAccess.xml");
        InputStreamReader actualXml =
            new InputStreamReader(resp.getInputStream());
        assertXMLEqual(expectedXml, actualXml);
    }
    
}
